docum/urls.py
from django.urls import path
from django.contrib.auth import views
from django.views.generic import TemplateView
from .views import (ContragentList, ContragentCreate, ContragentUpdate, get_contragent, addition_claim,
    create_doc, create_spec, ContractList, ContractCreate, ContractUpdate, addition_download,
    ContractDetail, AdditionUpdate, AdditionDelete, AdditionDetail, addition_create, contract_download,
    export_contract, export_addition, export_contragent)
  


urlpatterns = [
    path('', TemplateView.as_view(template_name="docum/startpage.html")),
    path('export/', TemplateView.as_view(template_name="docum/export.html"), name='export'),
    path('login/', views.LoginView.as_view(), name='login'),
    path('logout/', views.LogoutView.as_view(), name='logout'),
    path('get_contragent/', get_contragent, name='get_contragent'),
    path('contragent/', ContragentList.as_view(), name='contragent_list'),
    path('contragent/create/', ContragentCreate.as_view(), name='contragent_create'),
    path('contragent/<int:pk>/update/', ContragentUpdate.as_view(), name='contragent_update'),
    path('claim/addition/', addition_claim, name='addition_claim'),
    path('contract/', ContractList.as_view(), name='contract_list'),
    path('contract/create/', ContractCreate.as_view(), name='contract_create'),
    path('contract/<int:pk>/', ContractDetail.as_view(), name='contract_detail'),
    path('contract/<int:pk>/update/', ContractUpdate.as_view(), name='contract_update'),
    path('contract/<int:pk>/createdoc/', create_doc, name='document_create'),
    path('contract/<int:pk>/download', contract_download, name='contract_download'),
    path('addition/create/', addition_create, name='addition_create'),
    path('addition/<int:pk>/delete/', AdditionDelete.as_view(), name='addition_delete'),
    path('addition/<int:pk>/update/', AdditionUpdate.as_view(), name='addition_update'),
    path('addition/<int:pk>/detail/', AdditionDetail.as_view(), name='addition_detail'),
    path('addition/<int:pk>/createspec/', create_spec, name='spec_create'),
    path('addition/<int:pk>/download', addition_download, name='addition_download'),
    path('export_contract/', export_contract, name='export_contract'),
    path('export_addition/', export_addition, name='export_addition'),
    path('export_contragent/', export_contragent, name='export_contragent'),
]

vekdoc/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('docum.urls')),
] + static(settings.MEDIA_URL, document_root = settings.MEDIA_ROOT)

docum/models.py
from django.db import models
from django.urls import reverse
from datetime import datetime, date, timedelta


# Create your models here.


class Contragent(models.Model):
    POSITION_CHOICES = [
        ('директор', 'директор'),
        ('голова', 'голова'),
        ('голова правління', 'голова правління'),]
    shortname = models.CharField(max_length=32)
    longname = models.CharField(max_length=128, unique=True)
    edrpou =  models.CharField(max_length=10)
    ipn =  models.CharField(max_length=12)
    address =  models.CharField(max_length=128)
    iban =  models.CharField(max_length=29)
    bank =  models.CharField(max_length=64)
    position = models.CharField(max_length=16, choices=POSITION_CHOICES, default='директор')
    leader = models.CharField(max_length=64)
    case_leader = models.CharField(max_length=64)
    phone = models.CharField(max_length=15, default='_')
    email = models.EmailField(max_length=64, default='_')
    contact = models.CharField(max_length=64)
    telcontact = models.CharField(max_length=15)

    class Meta:
        ordering = ['edrpou']

    def __str__(self):
        return '%s' % (self.shortname)


class Product(models.Model):
    PERIOD_CHOICES = [
        ('врожаю 2021 року', '2021 року'),
        ('врожаю 2022 року', '2022 року'),]
    shortname = models.CharField(max_length=24)
    longname = models.CharField(max_length=64)
    period = models.CharField(max_length=16, choices=PERIOD_CHOICES, default='2021 року')
    utkzed = models.CharField(max_length=14)
    dstu = models.CharField(max_length=9, blank=True, null=True)
    condition = models.CharField(max_length=640, blank=True, null=True)
    is_active = models.BooleanField(default=True)

    def __str__(self):
        return '%s %s' % (self.shortname, self.period)

    class Meta:
        ordering = ['shortname']


class Contract(models.Model):
    CASH_CHOICES = [
            ('Покупець здійснює передоплату у розмірі вартості Товару  без врахування суми ПДВ. Постачальник зобов’язується надати Покупцю нижчезазначені документи:', 'Передоплата'),
            ('Покупець оплачує вартість поставленого Товару без врахування суми ПДВ, протягом 3 (трьох) банківських днів, з дати наступної за днем підписання Сторонами видаткової накладної та отриманням Покупцем нижчезазначених документів:', 'Післяплата'),]
    number = models.CharField(max_length=10, unique=True)
    date = models.DateField(default=date.today)
    contragent = models.ForeignKey('Contragent', on_delete = models.CASCADE)
    cash = models.CharField(max_length=256, choices=CASH_CHOICES, default='Передоплата')
    file_contract = models.FileField(upload_to='contract/', blank=True, null=True)

    class Meta:
        ordering = ['-date']

    def __str__(self):
        return '%s %s' % (self.number, self.contragent)

    def get_absolute_url(self):
        return reverse('contract_detail', kwargs={'pk': self.pk})


class Addition(models.Model):
    PROCENT_CHOICES = [
        ('14%', '14%'),
        ('20%', '20%'),]
    TRADE_CHOICES = [
        ('CPT', 'CPT'),
        ('FCA', 'FCA'),
        ('DAP', 'DAP'),]
    number = models.CharField(max_length=10)
    date = models.DateField(default=date.today)
    contract = models.ForeignKey('Contract', on_delete = models.CASCADE)
    product = models.ForeignKey('Product', on_delete = models.CASCADE, blank=True, null=True)
    cost = models.FloatField(blank=True, null=True)
    tencent = models.BooleanField(default=False)
    procent = models.CharField(max_length=3, choices=PROCENT_CHOICES, default='14%')
    pdv = models.FloatField(blank=True, null=True)
    notpdv = models.FloatField(blank=True, null=True)
    quantity = models.FloatField(blank=True, null=True)
    sumcost = models.FloatField(blank=True, null=True)
    sumpdv = models.FloatField(blank=True, null=True)
    sumnotpdv = models.FloatField(blank=True, null=True)
    trade = models.CharField(max_length=16, choices=TRADE_CHOICES, default='FCA')
    addresstrade =models.CharField(max_length=200, blank=True, null=True)
    file_addition = models.FileField(upload_to='addition/', blank=True, null=True)

    class Meta:
        ordering = ['-date']

    def __str__(self):
        return '№%s %s %s' % (self.number, self.contract, self.product)

docum/forms.py
from django import forms
from .models import Contract, Addition



class ContractForm(forms.ModelForm):
    class Meta:
        model = Contract
        fields = ('contragent', 'number', 'date', 'cash', 'file_contract')
        widgets = {
            'contragent': forms.HiddenInput(),
            'date': forms.DateInput(format='%Y-%m-%d', attrs={'type':'date'}),}




class AdditionForm(forms.ModelForm):
    class Meta:
        model = Addition
        fields = ('number', 'date', 'contract', 'product', 'cost', 'procent', 'pdv', 'notpdv', 'quantity',
        'sumcost', 'sumpdv', 'sumnotpdv', 'trade', 'addresstrade', 'file_addition', 'tencent')
        widgets = {
            'contract': forms.HiddenInput(),
            'claim': forms.HiddenInput(),
            'date': forms.DateInput(format='%Y-%m-%d', attrs={'type':'date'}),}

docum/views.py
import xlwt, csv, io, os
import jinja2
import locale
from io import BytesIO
from num2words import num2words
from django.db import IntegrityError
from django.urls import reverse_lazy, reverse
from datetime import datetime, date, time, timedelta
from vekdoc.settings import BASE_DIR
from django.shortcuts import render, redirect
from django.db.models import Q, F, Sum
from django.db.models.functions import Cast, Coalesce
from docxtpl import DocxTemplate
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.http import JsonResponse, HttpResponse, FileResponse
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from .models import Contragent, Product, Contract, Addition
from .forms import ContractForm, AdditionForm
# Create your views here.



def multiple(str, value):
    for i, j in value.items():
        str = str.replace(i, j)
    return str


def toFixed(value, digits=2):
    return f'{value:.{digits}f}'


def outnumber(value):
    list = {'.': ','}
    strnumber = str(toFixed(value))
    number = strnumber[-12:-9]+' '+strnumber[-9:-6]+' '+strnumber[-6:]
    out = multiple(number, list)
    return out


def first(value):
   return value.title()


def convert_date(s):
    s = datetime.fromordinal(datetime(1900, 1, 1).toordinal() + int(s) - 2).strftime('%Y-%m-%d')
    return s


def nword(value):
    list = {'одна кома': 'одна гривня', 'двi кома': 'дві гривні', 'три кома': 'три гривні',
        'чотири кома': 'чотири гривні',  'кома': 'гривень', 'одна копійок': 'одна копійка',
        'двi копійок': 'дві копійки', 'три копійок': 'три копійки', 'чотири копійок': 'чотири копійки'}
    strnumber = str(toFixed(value))
    number = num2words(strnumber, lang='uk')
    fnumber = number+' копійок'
    numword = multiple(fnumber, list)
    return numword



def get_contragent(request):
    if 'term' in request.GET:
        qs = Contragent.objects.filter(longname__icontains=request.GET.get('term'))
        results = list()
        for contragent in qs:
            contragent_json = {'label': contragent.shortname, 'value': contragent.shortname}
            contragent_json['idn'] = contragent.id
            contragent_json['edrpou'] = contragent.edrpou
            results.append(contragent_json)
        return JsonResponse(results, safe=False)



class ContragentCreate(CreateView):
    model = Contragent
    fields = '__all__'
    success_url = reverse_lazy('contragent_list')


class ContragentUpdate(UpdateView):
    model = Contragent
    fields = '__all__'
    success_url = reverse_lazy('contragent_list')


class ContragentList(ListView):
    model = Contragent
    paginate_by = 25

    def get_queryset(self, *args, **kwargs):
        query_name = self.request.GET.get('name')
        if query_name:
            queryset = super().get_queryset().filter(
            Q(longname__icontains=query_name) | Q(edrpou__icontains=query_name))
        else:
            queryset = super().get_queryset().all()
        return queryset



class ContractCreate(CreateView):
    form_class = ContractForm
    template_name = 'docum/contract_create.html'


class ContractUpdate(UpdateView):
    model = Contract
    form_class = ContractForm
    template_name = 'docum/contract_form.html'


class ContractList(ListView):
    model = Contract
    paginate_by = 25

    def get_queryset(self, *args, **kwargs):
        query_name = self.request.GET.get('name')
        if query_name:
            queryset = super().get_queryset().filter(
            Q(number__icontains=query_name) | Q(contragent__longname__icontains=query_name))
        else:
            queryset = super().get_queryset().all()
        return queryset


class ContractDetail(DetailView):
    model = Contract


def contract_download(request, pk):
    obj = Contract.objects.get(pk=pk)
    filename = obj.file_contract.path
    response = FileResponse(open(filename, 'rb'))
    return response


def addition_create(request):
    if request.method == "POST":
        getting = request.POST.get('contract')
        contract = Contract.objects.get(id=getting)
#        if Addition.objects.filter(contract=contract).count() == 0:
#            number = 1
#        else:
#            add = Addition.objects.filter(contract=contract).first()
#            number = int(add.number) + 1
#        addition = Addition(contract=contract, number=number)
        addition = Addition(contract=contract)
        addition.save()
        return redirect('addition_update', pk=addition.pk)


def addition_claim(request):
    if request.method == "POST":
        contragent = Contragent.objects.get(shortname=request.POST.get('contrname'))
        contract = Contract.objects.get(contragent=contragent.id)
        claim = Claim.objects.get(id=request.POST.get('claim'))
        if Addition.objects.filter(contract=contract).count() == 0:
            number = 1
        else:
            add = Addition.objects.filter(contract=contract).first()
            number = int(add.number) + 1
        addition = Addition(contract=contract, number=number, claim=claim)
        addition.save()
        return redirect('addition_update', pk=addition.pk)


class AdditionUpdate(UpdateView):
    model = Addition
    form_class = AdditionForm

    def get_success_url(self):
        getting = self.request.POST.get('contract')
        return reverse('contract_detail', kwargs={'pk': getting})


class AdditionDetail(DetailView):
    model = Addition

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['loading'] = Transport.objects.filter(addition=self.object.id).aggregate(Sum('loading'))['loading__sum']
        context['discharging'] = Transport.objects.filter(addition=self.object.id).aggregate(Sum('discharging'))['discharging__sum']
        return context


class AdditionDelete(DeleteView):
    model = Addition
    success_url = reverse_lazy('contract_list')


def addition_download(request, pk):
    obj = Addition.objects.get(pk=pk)
    filename = obj.file_addition.path
    response = FileResponse(open(filename, 'rb'))
    return response


def create_doc(request, pk):
    contract = Contract.objects.get(pk=pk)
    list = {
        '/': '_', '-': '_', 'директор': 'директора', 'голова': 'голови', 'голова правління': 'голови правління', 'July': 'липня',
        'August': 'серпня', 'September': 'вересня', 'October': 'жовтня', 'November': 'листопада', 'December': 'грудня',
        'January': 'січня', 'February': 'лютого', 'March': 'березня', 'April': 'квітня', 'May': 'травня', 'June': 'червня'}
    list2 = {'/': '_', '-': '_', ' ': '_', '"': '_', '«': '_', '»': '_'}
    date = datetime.strftime(contract.date, '%d %B %Y')
    context = {
        'contract': contract.number, 'date': multiple(date, list), 'cash': contract.cash,
        'sname': contract.contragent.shortname,'cname': contract.contragent.case_leader,
        'phone': contract.contragent.phone, 'email': contract.contragent.email,
        'address': contract.contragent.address, 'iban': contract.contragent.iban,
        'bank': contract.contragent.bank, 'edrpou': contract.contragent.edrpou,
        'ipn': contract.contragent.ipn,'position1': contract.contragent.position,
        'position2': multiple(contract.contragent.position, list), 'leader': contract.contragent.leader}
    byte_io = BytesIO()
    jinja_env = jinja2.Environment()
    jinja_env.filters['first'] = first
    tpl = DocxTemplate(os.path.join(BASE_DIR, 'templates/tempd.docx'))
    tpl.render(context, jinja_env)
    tpl.save(byte_io)
    byte_io.seek(0)
    return FileResponse(byte_io, as_attachment=True, filename='договор_%s_%s.docx' % (multiple(contract.number, list),
        multiple(contract.contragent.shortname, list)))


def create_spec(request, pk):
    addition = Addition.objects.get(pk=pk)
    list = {
        '/': '_', '-': '_', 'директор': 'директора', 'голова': 'голови', 'голова правління': 'голови правління', 'July': 'липня',
        'August': 'серпня', 'September': 'вересня', 'October': 'жовтня', 'November': 'листопада', 'December': 'грудня',
        'January': 'січня', 'February': 'лютого', 'March': 'березня', 'April': 'квітня', 'May': 'травня', 'June': 'червня'}
    list2 = {'/': '_', '-': '_', ' ': '_', '"': '_', '«': '_', '»': '_'}
    delta = addition.date + timedelta(10)
    date = datetime.strftime(addition.date, '%d %B %Y')
    date2 = datetime.strftime(addition.date, '%d.%m.%Y')
    date3 = datetime.strftime(delta, '%d %B %Y')
    contract_date = datetime.strftime(addition.contract.date, '%d.%m.%Y')
    if addition.tencent == False:
        tencent = ' тонн.'
    else:
        tencent = ' тонн  +/-10%.'
    context = {
        'number': addition.number, 'date': multiple(date, list), 'date2': date2, 'date3': multiple(date3, list),
        'contract': addition.contract.number, 'contract_date': contract_date, 'tencent': tencent,
        'sname': addition.contract.contragent.shortname, 'lnameproduct': addition.product.longname,
        'year': addition.product.period, 'zed': addition.product.utkzed, 'dstu': addition.product.dstu,
        'condition': addition.product.condition, 'quantity': outnumber(addition.quantity),
        'cost': outnumber(addition.cost), 'pdv': outnumber(addition.pdv), 'procent': addition.procent,
        'notpdv': outnumber(addition.notpdv), 'sumcost': outnumber(addition.sumcost),
        'sumpdv': outnumber(addition.sumpdv), 'sumnotpdv': outnumber(addition.sumnotpdv),
        'trade': addition.trade, 'numword': nword(addition.sumcost), 'addresstrade': addition.addresstrade,
        'cname': addition.contract.contragent.case_leader, 'phone': addition.contract.contragent.phone,
        'email': addition.contract.contragent.email, 'address': addition.contract.contragent.address,
        'iban': addition.contract.contragent.iban, 'bank': addition.contract.contragent.bank,

docum/templates/docum/addition_confirm_delete.html
{% extends 'base.html' %}

{% block body %}
<h2><a style="padding:10px;" href="{% url 'contract_detail' addition.contract.id %}"><i class="fas fa-caret-square-left"></i></a></h2>
<div class="card">
      <div class="card-body">
      <form method="post">{% csrf_token %}
            <h2 align=center class="blink">Ви дійсно хочете видалити</h2>
            <h2 align=center class="blink">специфікацію - {{ object }}?</h2>
              <br><button type="submit" class="btn">Видалити</button>
        </form>
    </div>
</div>
{% endblock %}

docum/templates/docum/addition_form.html
{% extends 'base.html' %}

{% block body %}
<h2><a style="padding:10px;" href="{% url 'contract_detail' addition.contract.id %}"><i class="fas fa-caret-square-left"></i></a></h2>
<div class="forms">
  <div class="card-body">
  <h2>Введення/редагування специфікації</h2>
  <form enctype="multipart/form-data" method="POST">
    {% csrf_token %}

    <div class="row">
      <div style="width: 50%;">
        <div class="column">
          <label for="id_number">Номер специфікації</label>
          {{ form.number }}
        </div>
      </div>
      <div style="width: 50%;">
        <div class="column">
          <label for="id_date">від</label>
          {{ form.date }}{{ form.date.errors }}
        </div>
      </div>
    </div>

    <div class="row">
      <div style="width: 45%;">
        <div class="column">
        <label for="contract">Контракт</label>
          <input disabled type="text" name="contract" id="contract" value="{{ addition.contract.number }} - {{ addition.contract.contragent.shortname }}">
          {{ form.contract }}
        </div>
      </div>
      <div style="width: 45%;">
        <div class="column">
          <label for="id_product">Культура</label>
          {{ form.product }}{{ form.product.errors }}
        </div>
      </div>
      <div style="width: 10%;">
        <div class="column">
          <label for="id_tencent">10%</label>
          {{ form.tencent }}{{ form.tencent.errors }}
        </div>
      </div>
    </div>
    <br>
    <div class="row">
      <div style="width: 20%;">
        <div class="column">
        <label for="id_procent">Відсоток ПДВ</label>
          {{ form.procent }}{{ form.procent.errors }}
        </div>
      </div>
      <div style="width: 40%;">
        <div class="column">
        <label for="id_cost">Ціна за тонну</label>
          {{ form.cost }}{{ form.cost.errors }}
        </div>
      </div>
      <div style="width: 40%;">
        <div class="column">
          <label for="id_quantit">Кількість тонн</label>
          {{ form.quantity }}{{ form.quantity.errors }}
        </div>
      </div>
    </div>

    <div class="row">
      <div style="width: 50%;">
        <div class="column">
          <label for="id_notpdv">Ціна без ПДВ</label>
          {{ form.notpdv }}{{ form.notpdv.errors }}
        </div>
      </div>
      <div style="width: 50%;">
        <div class="column">
          <label for="id_notpdv">ПДВ</label>
          {{ form.pdv }}{{ form.pdv.errors }}
        </div>
      </div>
    </div>

    <div class="row">
      <div style="width: 33%;">
        <div class="column">
          <label for="id_sumnotpdv">Сума без ПДВ</label>
          {{ form.sumnotpdv }}{{ form.sumnotpdv.errors }}
        </div>
      </div>
      <div style="width: 33%;">
        <div class="column">
          <label for="id_sumpdv">у тому числі ПДВ</label>
          {{ form.sumpdv }}{{ form.sumpdv.errors }}
        </div>
      </div>
      <div style="width: 33%;">
        <div class="column">
          <label for="id_sumcost">Загальна сума</label>
          {{ form.sumcost }}{{ form.sumcost.errors }}
        </div>
      </div>
    </div>
    <br>
    <div class="row">
      <div style="width: 20%;">
        <div class="column">
        <label for="id_trade">Вид поставки</label>
          {{ form.trade }}{{ form.trade.errors }}
        </div>
      </div>
      <div style="width: 80%;">
        <div class="column">
          <label for="id_notpdv">Адреса поставки</label>
          {{ form.addresstrade }}{{ form.addresstrade.errors }}
        </div>
      </div>
    </div>

    <br><br><button type="submit" class="btn">Записати</button>
  </form>
</div>
</div>
{% endblock %}

docum/templates/docum/contract_create.html
{% extends 'base.html' %}

{% block body %}
<h2><a style="padding:10px;" href="{% url 'contract_list' %}"><i class="fas fa-caret-square-left"></i></a></h2>
<div class="forms">
  <div class="card-body">
  <h2>Введення/редагування договору</h2>

  <div class="row">
    <div style="width: 50%;">
      <div class="column">
        <label for="contragent">Контрагент</label>
        <input type="text" name="contragent" id="contragent">
      </div>
    </div>
    <div style="width: 50%;">
      <div class="column">
        <label for="edrpou">Код ЄДРПОУ</label>
        <input disabled type="text" id="edrpou" name="edrpou" value="">
      </div>
    </div>
  </div>

  <form method="POST">
    {% csrf_token %}

    <div class="row">
      <div style="width: 40%;">
        <div class="column">
        <label for="id_number">Номер договора</label>
          {{ form.number }}{{ form.contragent }}
        </div>
      </div>
      <div style="width: 30%;">
        <div class="column">
          <label for="id_date">вид договору</label>
          {{ form.cash }}
        </div>
      </div>
      <div style="width: 30%;">
        <div class="column">
          <label for="id_date">від</label>
          {{ form.date }}
        </div>
      </div>
    </div>

    <br><br><button type="submit" class="btn">Записати</button>
  </form>
</div>
</div>
{% endblock %}

docum/templates/docum/contract_form.html
{% extends 'base.html' %}

{% block body %}
<h2><a style="padding:10px;" href="{% url 'contract_list' %}"><i class="fas fa-caret-square-left"></i></a></h2>
<div class="forms">
  <div class="card-body">
  <h2>Введення/редагування договору</h2>

  <div class="row">
    <div style="width: 50%;">
      <div class="column">
        <label for="contragent">Контрагент</label>
        <input type="text" name="contragent" id="contragent" value="{{ contract.contragent.shortname }}">
      </div>
    </div>
    <div style="width: 50%;">
      <div class="column">
        <label for="edrpou">Код ЄДРПОУ</label>
        <input disabled type="text" id="edrpou" name="edrpou" value="{{ contract.contragent.edrpou }}">
      </div>
    </div>
  </div>

  <form enctype="multipart/form-data" method="post">
    {% csrf_token %}

    <div class="row">
      <div style="width: 40%;">
        <div class="column">
        <label for="id_number">Номер договора</label>
          {{ form.number }}{{ form.contragent }}
        </div>
      </div>
      <div style="width: 30%;">
        <div class="column">
          <label for="id_cash">вид договору</label>
          {{ form.cash }}{{ form.cash.errors }}
        </div>
      </div>
      <div style="width: 30%;">
        <div class="column">
          <label for="id_date">від</label>
          {{ form.date }}
        </div>
      </div>
    </div>

    <div class="row">
      <div style="width: 50%;">
        <div class="column">
          <label for="id_file_contract">Скан-копія</label>
          <input type="file" name="file_contract" id="id_file_contract">
        </div>
      </div>
    </div>

    <br><br><button type="submit" class="btn">Записати</button>
  </form>
</div>
</div>
{% endblock %}

docum/templates/docum/contragent_form.html
{% extends 'base.html' %}

{% block body %}
<h2><a style="padding:10px;" href="{% url 'contragent_list' %}"><i class="fas fa-caret-square-left"></i></a></h2>
<div class="forms">
  <div class="card-body">
    <h2>Введення/редагування в довідник контрагента</h2>
    <form method="post">
      {% csrf_token %}

      <div class="row">
        <div style="width: 50%;">
          <div class="column">
            <label for="id_shortname">Коротка назва</label>
            {{ form.shortname }}{{ form.shortname.errors }}
          </div>
        </div>
        <div style="width: 50%;">
          <div class="column">
            <label for="id_edrpou">Код ЄДРПОУ</label>
            {{ form.edrpou }}{{ form.edrpou.errors }}
          </div>
        </div>
      </div>

        <div class="column">
          <label for="id_longname">Повна назва</label>
          {{ form.longname }}{{ form.longname.errors }}
        </div>

        <div class="row">
          <div style="width: 20%;">
            <div class="column">
              <label for="id_position">Посада</label>
              {{ form.position }}{{ form.position.errors }}
            </div>
          </div>
          <div style="width: 40%;">
            <div class="column">
              <label for="id_leader">Керівник</label>
              {{ form.leader }}{{ form.leader.errors }}
            </div>
          </div>
          <div style="width: 40%;">
            <div class="column">
              <label for="id_case_leader">у родовому відмінку</label>
              {{ form.case_leader }}{{ form.case_leader.errors }}
            </div>
          </div>
        </div>

        <div class="row">
          <div style="width: 50%;">
            <div class="column">
            <label for="id_iban">Рахунок</label>
              {{ form.iban }}{{ form.iban.errors }}
            </div>
          </div>
          <div style="width: 50%;">
            <div class="column">
              <label for="id_ipn">Індивідуальний ПН</label>
              {{ form.ipn }}{{ form.ipn.errors }}
            </div>
          </div>
        </div>

        <div class="column">
          <label for="id_bank">Банк</label>
          {{ form.bank }}{{ form.bank.errors }}
        </div>

        <div class="column">
          <label for="id_adress">Повна адреса</label>
          {{ form.address }}{{ form.address.errors }}
        </div>

        <div class="row">
          <div style="width: 50%;">
            <div class="column">
            <label for="id_email">Електронна пошта підприємства</label>
              {{ form.email }}{{ form.email.errors }}
            </div>
          </div>
          <div style="width: 50%;">
            <div class="column">
              <label for="id_phone">Телефон підприємства</label>
              {{ form.phone }}{{ form.phone.errors }}
            </div>
          </div>
        </div>

        <div class="row">
          <div style="width: 50%;">
            <div class="column">
            <label for="id_contact">Контактна особа</label>
              {{ form.contact }}{{ form.contact.errors }}
            </div>
          </div>
          <div style="width: 50%;">
            <div class="column">
              <label for="id_telcontact">телефон</label>
              {{ form.telcontact }}{{ form.telcontact.errors }}
            </div>
          </div>
        </div>


      <br><br><button type="submit" class="btn">Записати</button>
    </form>
  </div>
</div>
{% endblock %}

docum/templates/docum/mistake.html
{% extends  'base.html' %}

{% block body %}
{% if user.is_authenticated %}
<h2><a style="padding:10px;" href="{% url 'addition_detail' id_addition %}"><i class="fas fa-caret-square-left"></i></a></h2>
<div class="card">
  <div class="card-body">
    <h2 align=center class="blink">{{ message }}</h2>
  </div>
</div>
{% endif %}
{% endblock %}